#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <winioctl.h>
#include <dontuse.h>

VOID __cdecl
main(
    __in ULONG argc,
    __in_ecount(argc) PCHAR argv[]
    )
{

    // The following is returned by IOCTL.  It is true if the read succeeds.
    PUCHAR  Result;

    // The following parameters are used in the IOCTL call
    HANDLE  hndFile;            // Handle to device, obtain from CreateFile
    ULONG   PortNumber;         // Buffer sent to the driver (Port #).
    CHAR    DataBuffer[BUFSIZ];             // Buffer received from driver (Data).
    CHAR    NameBuffer[BUFSIZ];
    CHAR    junk[BUFSIZ];
    CHAR    Manufacture[BUFSIZ];
	DWORD   DataLength;
    DWORD   ReturnedLength;     // Number of bytes returned
    PCHAR   FileName;
	FILE    *pFile;
	INT     i;
	PCHAR   p;
	enum {
		STARTED,
		FOUND_MUNUFACTURE_SECT,
		FOUND_MUNUFACTURE_NAME,
		FOUND_MODELSECT_NAME,
		FOUND_MODELSECT,
		GOT_HWIDS
	}
	stage;

    if ( argc < 2 )
    {
		printf("Hardware IDs Help:\n\n");
        printf("HWIDs <inf-filename>\n\n");
        exit(1);
    }
	FileName = argv[1];
	pFile = fopen(
                FileName,                    // Open the Device "file"
				"r"
				);

    if (pFile == NULL)        // Was the device opened?
    {
        printf("Unable to open the inf file = %s\n", FileName);
        exit(1);
    }

	stage = STARTED;
	DataLength = BUFSIZ;
	do
	{
	    Result = fgets(
						    DataBuffer,        // Buffer from driver.
                            DataLength,         // Length of buffer in bytes.
                            pFile
                            );
		ReturnedLength = strlen(DataBuffer);
		DataBuffer[ ReturnedLength - 1] = '\0';
		// printf("Read req = %d, rtn = %d, result = %d\n", DataLength, ReturnedLength, Result);
		for( i = 0; i < ReturnedLength; i++ )
		{
			DataBuffer[ i ] = toupper( DataBuffer[ i ] );
		}
#if 0
		printf("Read req = %d, rtn = %d, line = %s\n", DataLength, ReturnedLength, DataBuffer);
#endif
		memset(NameBuffer, BUFSIZ, 0);

		switch( stage ) {
		case STARTED:
			if (strstr(DataBuffer, "MANUFACTURER") != NULL)
			{
				stage = FOUND_MUNUFACTURE_SECT;
				printf("FOUND_MUNUFACTURE_SECT:\n");
			}
			break;
		case FOUND_MUNUFACTURE_SECT:
			p = strchr(DataBuffer, '=');

#if 0
			if (p++ != NULL && (i = sscanf_s(p, "%[A-Z0-9_-]", NameBuffer)) > 0)
			{
				stage = FOUND_MUNUFACTURE_NAME;
				printf("FOUND_MUNUFACTURE_NAME: name = %s\n", NameBuffer);
			}
#endif
			if (p++ != NULL) {
				//i = sscanf_s(p, "%[A-Z0-9_-]", NameBuffer);
				i = sscanf_s(p, "%[A-Z0-9_-]%[;, A-Z0-9_-]", NameBuffer, BUFSIZ, junk, BUFSIZ);
				//printf("*** i = %d, p = %s, name = %s\n", i, p, NameBuffer);
				if(i > 0)
				{
				stage = FOUND_MUNUFACTURE_NAME;
				printf("FOUND_MUNUFACTURE_NAME: name = %s\n", NameBuffer);
				strcpy(Manufacture, NameBuffer);
				}
			}
			break;
		case FOUND_MUNUFACTURE_NAME:
			p = strchr(DataBuffer, '[');
	
			//printf("MODEL-before: <%s> (%s)\n", p, Manufacture);
			if (p++ != NULL) {
				//p = SearchKeyword(Manufacture, p);
				p = strstr(p, Manufacture);
				//printf("MODEL-after: <%s>\n", p);

				stage = FOUND_MODELSECT_NAME;
				printf("FOUND_MODELSECT_NAME: name = %s\n", p);
			}
			break;
		case FOUND_MODELSECT_NAME:
			p = strchr(DataBuffer, '[');

			if (p != NULL)
			{
				stage = GOT_HWIDS;
				break;
			}
			p = strchr(DataBuffer, '=');
			if (p != NULL)
			{
				p++;
				p = strchr(DataBuffer, ',');
			}

			while(p != NULL && *p != '\0')
			{
				memset(NameBuffer, BUFSIZ, 0);
				i = sscanf_s(p, "%[;, ]%[^;, ]", junk, BUFSIZ, NameBuffer, BUFSIZ);
				if (i > 0 && NameBuffer[0]) {
					printf("HWID = <%s>\n", NameBuffer);
				}
				else break;
				p += strlen(NameBuffer);
			}
			break;
		case GOT_HWIDS:
		default:
			break;
		}
	}
	while (Result > 0);

    (void) fclose(pFile);

    exit(0);
}
